#include "Grid.hpp"

//Constructor
Grid::Grid(): m_size(4), m_grid(4){

	//Init all cells
	for(int i=0;i<m_size;i++){
		for(int j=0;j<m_size;j++){
			m_grid.at(i).push_back(0);
		}
	}

}

//Destructor
Grid::~Grid(){
}


std::string Grid::description(){

	//Init stringstream description
	std::stringstream description;

	//Start to write description
	description << "-----------------" << std::endl;
	for(int i=0;i<m_size;i++){
		for(int j=0;j<m_size;j++){
			if(m_grid.at(i).at(j) == 0)
				description << "| " << " " << " ";
			else
				description << "| " << m_grid.at(i).at(j) << " ";
		}
		description << "|";
		description << std::endl;
	}
	description << "-----------------" << std::endl << std::endl;

	//Return description
	return description.str();
}

bool Grid::isEmpty(int i, int j){
	if(m_grid.at(i).at(j) == 0)
		return true;
	return false;
}

std::tuple<int, int> Grid::getRandomEmptyCellCoord(){

	//Init list of candidate
	std::vector<std::tuple<int, int> > candidates;

	//Construct list of candidates
	for(int i=0;i<m_size;i++){
		for(int j=0;j<m_size;j++){
			if(this->isEmpty(i,j)){
				std::tuple<int, int> currentCandidate(i,j);
				candidates.push_back(currentCandidate);
			}
		}
	}

	//If no candidate available
	if(candidates.size() == 0)
		return std::tuple<int, int>(-1, -1);

	//Select the candidates
	int winnerIs(rand() % candidates.size());

	//Return the candidate
	return candidates.at(winnerIs);

}



//Change value of cell
bool Grid::setCell(std::tuple<int, int> coord, int value){
	int i=std::get<0>(coord); 
	int j=std::get<1>(coord); 

	if(i>=0 && i<m_size && j>=0 && j<m_size){
		m_grid.at(i).at(j)=value;
		return true;
	}

	return false;
}

//Another setCell method
bool Grid::setCell(int i, int j, int value){
	std::tuple<int, int> coord(i,j);
	return this->setCell(coord, value);
}





