#ifndef	DEF_GRID
#define	DEF_GRID

/* Grid.h
 * Defines the class Grid
 * A grid contains a table of cells the game will be set on
 * Creators : krilius, manzerbredes
 * Date : 29/04/2015 */

#include <iostream>
#include <sstream>
#include <vector>
#include <tuple>

class Grid
{
	private:
		int m_size;
		std::vector<std::vector<int> > m_grid;

	public:
		Grid();
		~Grid();

		std::string description();
		bool isEmpty(int i, int j);
		std::tuple<int, int> getRandomEmptyCellCoord();

		bool setCell(std::tuple<int, int> coord, int value);
		bool setCell(int i, int j, int value);
};


#endif
